// Package grpc is responsive for creating gRPC service
package grpc

import (
	"context"
	"fmt"

	"gitlab.com/ivan.feofanov/tristagramm/repository"
)

type Server struct {
	UnimplementedTristagrammServer
	Repo *repository.Repository
}

func (s *Server) GetPostsList(_ context.Context, request *GetPostListRequest) (*GetPostListResponse, error) {
	posts := []*Post{}

	dbPosts, err := s.Repo.Posts.GetAll(request.UserId)
	if err != nil {
		return nil, fmt.Errorf("%w", err)
	}

	for _, post := range dbPosts {
		posts = append(posts, &Post{
			UserId:    post.UserID.String(),
			PostId:    post.UID.String(),
			Text:      post.Text,
			CreatedAt: post.CreatedAt.String(),
		})
	}

	return &GetPostListResponse{
		Posts: posts,
	}, nil
}

func (s *Server) GetPostsStream(
	request *GetPostListRequest, srv Tristagramm_GetPostsStreamServer, //nolint: nosnakecase //name is autogenerated by proto
) error {
	dbPosts, err := s.Repo.Posts.GetAll(request.UserId)
	if err != nil {
		return fmt.Errorf("%w", err)
	}

	for _, post := range dbPosts {
		postData := &Post{
			UserId:    post.UserID.String(),
			PostId:    post.UID.String(),
			Text:      post.Text,
			CreatedAt: post.CreatedAt.String(),
		}
		if err = srv.Send(postData); err != nil {
			return fmt.Errorf("%w", err)
		}
	}

	return nil
}
